<?php

/**
 * webEdition CMS
 *
 * $Rev: 8665 $
 * $Author: mokraemer $
 * $Date: 2014-12-02 17:11:48 +0100 (Tue, 02 Dec 2014) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
function we_tag_navigation($attribs){
	$parentid = weTag_getAttribute("parentid", $attribs, -1, we_base_request::INT);
	$id = weTag_getAttribute("id", $attribs, 0, we_base_request::INT);
	$name = weTag_getAttribute("navigationname", $attribs, "default", we_base_request::STRING);

	$GLOBALS['we_navigation'][$name] = new we_navigation_items();
	if(isset($GLOBALS['initNavigationFromSession']) && $GLOBALS['initNavigationFromSession']){
		$showRoot = ($parentid == -1);
		$GLOBALS['we_navigation'][$name]->initByNavigationObject($showRoot);
	} else {
		$realId = ($id ? : ($parentid != -1 ? $parentid : 0));
		$showRoot = ($id ? true : ($parentid == -1));
		if(!$GLOBALS['we_navigation'][$name]->initFromCache($realId, $showRoot)){
			//make sure we use cache next time!
			$GLOBALS['we_navigation'][$name]->initById($realId, false, $showRoot);
			we_navigation_cache::saveCacheNavigation($realId, $GLOBALS['we_navigation'][$name]);
		}
	}
}
